using System;
using System.IO;
using Zcu.Mve.Core;
using Zcu.Mve.Strings;

namespace Zcu.Mve.Visualization
{
    /// <summary>
    /// Tda pro uloen bod do PTS souboru.
    /// </summary>
    class PTSSaver : Module
    {
        /// <summary>
        /// Jmno vstupnho souboru.
        /// </summary>
        private string filename = null;
        /// <summary>
        /// Data ze vstupu.
        /// </summary>
        private UniformDataArray data = null;
        /// <summary>
        /// Uruje zmnu nzvu souboru.
        /// </summary>
        private bool newFile = false;

        public string FileName
        {
            get { return filename; }
            set
            {
                this.filename = value;
                this.newFile = true;
            }
        }

        /// <summary>
        /// Konstruktor vytvejc porty.
        /// </summary>
        public PTSSaver()
        {
            this.AddInPort("Point3D array", typeof(UniformDataArray));
            this.AddInPort("filename", typeof(MveString),false);
        }

        /// <summary>
        /// Vstupn bod modulu. Zape body do souboru.
        /// </summary>
        public override void Execute()
        {
            if (!IsAllDataSame())
            {
                if (this.GetInPort("filename").Link != null)
                {
                    this.FileName = ((MveString)GetInput("filename")).Value;
                }
                newFile = true; 
            }
            if (newFile)
            {
                newFile = false;
                data = (UniformDataArray)GetInput("Point3D array");
                StreamWriter writer = new StreamWriter(FileName);
                writer.WriteLine(data.Count);
                for (int i = 0; i < data.Count; i++)
                {
                    writer.Write(((Point3D)data[i]).X + " ");
                    writer.Write(((Point3D)data[i]).Y + " ");
                    writer.WriteLine(((Point3D)data[i]).Z);
                }
                writer.Close();
            }
        }
    }
}